<html>
  <head>
    <title>Tabletop control panel</title>
    <link rel='stylesheet' href='./webcontrols.css'/>
    <script type='text/javascript' src='./webcontrols.js'></script>
  </head>
  <body style='width:800px'>
    <h1>Tabletop control panel</h1>
    <div class='button-bar'>
      <label>Doors:</label>
      <script>
        webcontrols.addButtonOnOff("door1", { on_text: "open 1", off_text: "close 1"}, function(value) { doCurl("d1" + (value ? "+" : "-")); });
        webcontrols.addButtonOnOff("door2", { on_text: "open 2", off_text: "close 2"}, function(value) { doCurl("d2" + (value ? "+" : "-")); });
        webcontrols.addButtonOnOff("door3", { on_text: "open 3", off_text: "close 3"}, function(value) { doCurl("d3" + (value ? "+" : "-")); });
        webcontrols.addButtonOnOff("door4", { on_text: "open 4", off_text: "close 4"}, function(value) { doCurl("d4" + (value ? "+" : "-")); });
        webcontrols.addButtonOnOff("gate", { on_text: "Gate on A", off_text: "Gate on B", on_color: "yellow", off_color: "yellow" }, function(value) { doCurl("g" + (value ? "a" : "b")); });
      </script>
    </div>
    <div class='button-bar'>
      <label>Covers:</label>
      <script>
        webcontrols.addButtonOnOff("cover1", { on_text: "open 1", off_text: "close 1"}, function(value) { doCurl("c1" + (value ? "+" : "-")); });
        webcontrols.addButtonOnOff("cover2", { on_text: "open 2", off_text: "close 2"}, function(value) { doCurl("c2" + (value ? "+" : "-")); });
        webcontrols.addButtonOnOff("cover3", { on_text: "open 3", off_text: "close 3"}, function(value) { doCurl("c3" + (value ? "+" : "-")); });
        webcontrols.addButtonOnOff("cover4", { on_text: "open 4", off_text: "close 4"}, function(value) { doCurl("c4" + (value ? "+" : "-")); });
      </script>
    </div>
    <div class='button-bar'>
      <label>Wagon:</label>
      <button onclick='doCurl("w<"+range)' style='background-color:yellow'>Left</button>
      <button onclick='doCurl("w>"+range)' style='background-color:yellow'>Right</button>
      <script>webcontrols.addButtonRange("range", { min: 0, max: 1000, width: 150});</script>
     </div>
     <div class='button-bar'>
      <label>Ozon:</label>
      <button onclick='doCurl("o<");' style='background-color:yellow'>Left</button>
      <button onclick='doCurl("o>");' style='background-color:yellow'>Right</button>
      <button onclick='doCurl("of"+forward);' style='background-color:yellow'>Forward</button>
      <script>webcontrols.addButtonRange("forward", { min: 1, max: 4, default: 1, precision: 1, width: 50});</script>
    </div>
    <div class='button-bar'>
      <label>Camera:</label>
      <button onclick='doVision()' style='background-color:yellow'>Grab</button>
      <button onclick='doVision("i0")' style='background-color:yellow'>View</button>
    </div>
    <div class='button-bar'>
      <label>Scene:</label>
      <button onclick='doVision("i"+room+"s", "input")' style='background-color:yellow'>Shift</button>
      <button onclick='doVision("i"+room+"p", "draw")' style='background-color:yellow'>Parse</button>
      <button onclick='doVision("i"+room+"d", "draw")' style='background-color:yellow'>Detect</button>
      <script>webcontrols.addButtonRange("room", { min: 1, max: 4, default: 1, precision: 1, width: 50});</script>
    </div>
    <center>
      <img id='display' src='./input.png' style='width:640px;height:480px;background-color:gray' alt='view'/>
    </center>
    <script>
      webcontrols.addConsole(true);
      function doCurl(command) {
        webcontrols.curl("@/_ccwrapper", "command="+encodeURIComponent(command), "POST");
      }
      function doVision(command = "i", view = "input") {
        webcontrols.curl("@/_ccwrapper", "command=" + command, "POST", function(value) {
          let path = value.replace(new RegExp(".*'([^']*)'.*"), "$1");
          document.getElementById("display").src = "../"+path+"/"+ view + ".png";
          webcontrols.loadJSON("../"+path+"/parameters.json", function(value) {
            webcontrols.consoleLog(value);
          });
        });
      }
    </script>
  </body>
</html>
